/* The entire gui is here */

extern char memnames[10][256];

/* Windows */


#define BGCOL 1
#define TXTCOL 15
#define SHORTCUTCOL 10
#define REVERSECOL 7
#define BORDERCOL 15

/* Struct to hold window data */

#define TOPLEFT 0x1
#define TOPRIGHT 0x2
#define BOTLEFT 0x4
#define BOTRIGHT 0x8

struct gui_window {
  UBY x1,y1,x2,y2;
  UBY fgcolor;
  UBY bgcolor;
  UBY shortcutcolor;
  UBY reversecolor;
  UBY cornerflags;
};

void gui_clearwindow(struct gui_window *w, int borderclear);
void gui_printwindowborders(struct gui_window *w);
void gui_plot_text_window(struct gui_window *w,char *s,ULO x,ULO y);
void gui_plot_text_window_reverse(struct gui_window *w,char *s,ULO x,ULO y);
void gui_plot_text_window_shortcut(struct gui_window *w,char *s,ULO x,ULO y,ULO shortcutpos);
void gui_plot_text_window_reverse_shortcut(struct gui_window *w,char *s,ULO x,ULO y,ULO shortcutpos);
void gui_initwindow(struct gui_window *w,UBY x1, UBY x2, UBY y1, UBY y2, UBY bgcolor, UBY fgcolor, UBY shortcutcolor, UBY reversecolor, UBY cornerflags);
void gui_spaces_to_eol(struct gui_window *w, char *s, ULO y);
void gui_setupscreen(void);
void gui_closescreen(void);


/* Menus */

struct gui_menu {
  char **entrytext;
  ULO activeentry;
  struct gui_window *w;
  UBY *shortcuts;
};

void gui_initmenu(struct gui_menu *m,char *entries[],ULO activeentry,struct gui_window *w, UBY *shortcuts);
ULO gui_menu_select(struct gui_menu *m);
void gui_menu_print(struct gui_menu *m);

/* option-menu */

struct gui_optionmenu {
        char *topheader;
        char **headers;
        UBY *actions;
        void *vars;
        char ***texts;
        void **vals;
        struct gui_window *w;
        UBY *shortcuts;
};

void gui_initoptionmenu(struct gui_optionmenu *om,char *topheader,char **headers,UBY *actions,void *vars,char ***texts,void **vals,struct gui_window *w,UBY *shortcuts);
void gui_optionmenu_run(struct gui_optionmenu *om);
void gui_clear_memnames(void);

#define GUI_FILEREQ_ALL 0
#define GUI_VALUELIST 1
#define GUI_FILEREQ_ROM 2
#define GUI_FILEREQ_ADF 3
#define GUI_FILEREQ_HDF 4
#define GUI_FILEREQ_KEY 5

#define GUI_OPTIONMENU_DEC 0
#define GUI_OPTIONMENU_INC 1

extern int exitflag;
extern char config_diskpath[];
extern ULO config_altn_loop;
extern char menupos_act[];
extern char menupos_want0[];
extern char menupos_want1[];
extern ULO config_store_mpos;
extern ULO config_autorun;


struct gui_numberfield {
  ULO x,y;      /* Start position in window */
  ULO value;
  struct gui_window *hostwindow;
  ULO hex;
};

void gui_numberfield_enter(struct gui_numberfield *n);
void gui_initnumberfield(struct gui_numberfield *n,struct gui_window *w,ULO v,ULO x,ULO y,ULO hex);






